
def readOffers():
    fname = "offers.txt"
    with open(fname, 'rb') as f:
        ret = []
        while True:
            line = f.readline()
            if len(line) < 1 :
                break
            fields = line.split()
            offer = {}
            offer["instrument"] = fields[0]
            ccy = fields[0].split('/')
            cc = ""
            pc = ""
            if len(ccy) > 1:
                if ccy[1] == "USD":
                    cc = ccy[1]
                    pc = ccy[0]
                else:
                    cc = ccy[0]
                    pc = ccy[1]
            else:
                cc = "USD"
                pc = ccy[0]
                
            offer["instrument"] = fields[0].strip()
            offer["currency"] = cc
            offer["profitCurrency"] = pc
            offer["contractCurrency"] = cc
            offer["mmr"] = fields[11].strip()
            ret.append(offer)
        return ret  

if __name__ == "__main__":
    offers = readOffers()
    print offers


