import os, sys


def findPass(content, str_pass):
    pattern = "pass number=\"" + str_pass + "\" success=\"true\" result="
    idx = content.find(pattern)
    if idx == -1:
        return 0
    idx += len(pattern) + 1
    idx1 = content.find("\"", idx)
    if idx1 == -1:
        return 0
    rs = content[idx : idx1]
    return float(rs)

    

def handleContent(content):
    pattern = "optimization-result success=\"true\" pass-number="
    idx = content.find(pattern)
    if idx == -1:
        return 0, 0
    idx += len(pattern) + 1
    idx1 = content.find("\"", idx)
    if idx1 == -1:
        return 0, 0
    str_pass = content[idx : idx1]
    rs = findPass(content, str_pass)
    return int(str_pass), rs

def handleFolder(path):
    out = {}
    for f in os.listdir(path):
        if not f.endswith(".stat"):
            continue    
        name = f
        begin_stub = "template.xml_";    
        end_stub = ".stat";
        idx_begin = f.find(begin_stub)  
        if idx_begin != -1:
            idx_begin += len(begin_stub)
            idx_end = f.find(end_stub, idx_begin)
            if idx_end != -1:
                name = f[idx_begin : idx_end]
        ps = 0
        rs = 0
        with open(path + "/" + f) as ff:
            content = ff.read()
            ps, rs = handleContent(content)
        #print name, rs
        out[rs] = name

    sorted_out = sorted(out, reverse=True)
    for k in sorted_out:
        print k, out[k]

def work(args):
    if len(args) < 2:
        print "Usage: report.py <folder with results>"
        return

    path=args[1]
    handleFolder(path)

work(sys.argv)

